<?php

//    
define('VAPHP', 1);
$CONF = array();
$FORM = array();
$TMPL = array();

$CONF['path'] = '.';

//   1   SQL   GET/POST/COOKIE 
$CONF['debug'] = 0;

// . 
require_once("{$CONF['path']}/settings.php");
require_once("{$CONF['path']}/config.php");

//    
require_once("{$CONF['path']}/sources/classes.php");
$base = new base;
$TIMER = new timer;

//   
require_once("{$CONF['path']}/sources/mysql.php");
$DB = new sql_mysql;
$DB->connect($CONF['sql_host'], $CONF['sql_username'], $CONF['sql_password'], $CONF['sql_database'], $CONF['debug']);

//      $CONF
$settings = $DB->fetch("SELECT * FROM {$CONF['sql_prefix']}_settings", __FILE__, __LINE__);
$CONF = array_merge($CONF, $settings);

$result = $DB->query("SELECT id, name FROM {$CONF['sql_prefix']}_cat ORDER BY name", __FILE__, __LINE__);
while (list($id, $category) = $DB->fetch_array($result)) 
{
  $CONF['categories'][$id]=$category;
}

$result = $DB->query("SELECT id, idcat, name FROM {$CONF['sql_prefix']}_subcat ORDER BY name", __FILE__, __LINE__);
while (list($id, $idcat, $subcategory) = $DB->fetch_array($result)) 
{
  $CONF['subcategories'][$idcat][$id]=$subcategory;
}

$CONF['skins_path'] = "{$CONF['path']}/skins";
$CONF['skins_url'] = "{$CONF['site_url']}/skins";
$CONF['skin_name'] = $CONF['default_skin'];
$CONF['skins_image'] = "{$CONF['skins_url']}/{$CONF['skin_name']}/images";
$TMPL['skins_image'] = $CONF['skins_image'];
$TMPL['skins_url'] = $CONF['skins_url'];
$TMPL['list_name'] = $CONF['list_name'];
$TMPL['site_url'] = $CONF['site_url'];

//  GET  POST 
$FORM = array_merge($_GET, $_POST);

//  
require_once("{$CONF['path']}/languages/{$CONF['default_language']}.php");

//  
$TMPL['skin_name'] = $CONF['default_skin'];

require_once("{$CONF['path']}/sources/skin.php");

//     install
if (file_exists("{$CONF['path']}/install/")) 
{
  $TMPL['header'] = $LNG['g_error'];
  $base->error($LNG['g_delete_install']);
}

//  
$num_check_site = 1;
$curr_time=time();
if($CONF['backlink_require'])
{
  $result = $DB -> select_limit("SELECT id, URL_backlink FROM {$CONF['sql_prefix']}_sites WHERE check_possible='1' and check_flag='1' and timecheck_next < '{$curr_time}' and check_admin='1'", $num_check_site, '', __FILE__, __LINE__);
  if ($DB -> num_rows($result))
  {
    while($result_sites=mysql_fetch_array($result))
    {
      if($base->is_backlink($result_sites['URL_backlink'])) $base->to_active($result_sites['id']);
      else $base->to_reduce($result_sites['id']);
    }
  }
}


//    .php    sources
$action = array(
            'admin' => 1,
            'add'   => 1,
            'cat'   => 1,
            'subcat'=> 1,
            'site'  => 1,
            'search'=> 1,
            'rules' => 1,
            'redirect' => 1
          );

//   
if (isset($FORM['a']) && isset($action[$FORM['a']])) 
{
  $page_name = $FORM['a'];
}
else 
{
  $page_name = 'catalog';
}

require_once("{$CONF['path']}/sources/{$page_name}.php");
$page = new $page_name;

//  
$skin = new main_skin('wrapper');
echo $skin->make();

$DB->close();

//      
if ($CONF['debug']) 
{
  foreach ($DB->queries as $value) 
  {
    echo "<hr /><pre>{$value}</pre>";
  }
  echo '<hr /><pre>';
  print_r($_REQUEST);
  echo '</pre>';
}
?>
